// -------------------------------------------------------
//
// Author: Thomas Lenart    
// Email:  thomas.lenart@es.lth.se
// Date:   March 2003
//
// -------------------------------------------------------
#include "main.h"

#ifdef DEBUG_INVERSION
#include <stdio.h>
#endif

#include "inversion.h"

void frequency_inversion(fixed_point matrix[MAX_SB*MAX_SS])
{
	int sb, ss;
	#ifdef DEBUG_INVERSION
	FILE* file;
	#if DATA_WIDTH == 32
	file = fopen("debug_data/debug_inversion_32.txt", OUTPUT_FILE_TYPE);
	#else 
	file = fopen("debug_data/debug_inversion_16.txt", OUTPUT_FILE_TYPE);
	#endif
	#endif

	for (sb = 1; sb < MAX_SB; sb += 2)
		for (ss = 1; ss < MAX_SS; ss += 2)
			matrix[sb*MAX_SS+ss] = -matrix[sb*MAX_SS+ss];	// All odd subband samples in all odd subbands

	#ifdef DEBUG_INVERSION
	for (ss = 0; ss < 576; ++ss)
		fprintf(file, "hybridOut[x][%d][%d] %.10f\n", ss / 18, ss % 18, fixed_to_double(matrix[ss]));
	fclose(file);
	#endif
}
