#if NEW_TRUNCATE == 1
int temp;
#endif

#if NEW_MDCT == 0
// This is what we have in hardware
	for (i = 0; i < 16; i++) {
		VOffsetPtr[i] = 0;
		#if NEW_TRUNCATE == 1
			temp = 0;
		#endif
		for (k = 0; k < 32; k++) {
			#if NEW_TRUNCATE == 1
				temp += (int)bandPtr_fix[k] * (int)table_cos[i][k];
			#else
				VOffsetPtr[i] += fix_mul(bandPtr_fix[k], table_cos[i][k]);
			#endif
		}
		#if NEW_TRUNCATE == 1
			VOffsetPtr[i] = temp >> (16 - INTEGER_BITS - 1);
		#endif
	}

	for (i = 48; i < 64; i++) {
		VOffsetPtr[i] = 0;
		#if NEW_TRUNCATE == 1
			temp = 0;
		#endif
		for (k = 0; k < 32; k++) {
			#if NEW_TRUNCATE == 1
				temp += (int)bandPtr_fix[k] * (int)table_cos[i][k];
			#else
				VOffsetPtr[i] += fix_mul(bandPtr_fix[k], table_cos[i][k]);
			#endif
		}
		#if NEW_TRUNCATE == 1
			VOffsetPtr[i] = temp >> (16 - INTEGER_BITS - 1);
		#endif
	}
#endif

#if NEW_MDCT == 1
	#ifdef DEBUG_SUBSYN
	if (ch_count == TARGET_CHANNEL || STEREO == 1) {
		#if DATA_WIDTH == 32
			file = fopen("debug_data/debug_mdct_intermediate_32.txt", OUTPUT_FILE_TYPE);
		#else
			file = fopen("debug_data/debug_mdct_intermediate_16.txt", OUTPUT_FILE_TYPE);
		#endif
		fprintf(file, "// This is frame %d, gr %d, ch %d, SS %d\n", frame_count, gr_count, ch_count, ss);
	}
	#endif

	for (i = 0; i < 32; i++) {
		X_Prime[i] = 0;
		for (k = 0; k < 32; k++) {
			X_Prime[i] += fix_mul(bandPtr_fix[k], table_cos[i][k]);
			#ifdef DEBUG_SUBSYN
				fprintf(file, "i=%d k=%d di=%0*X coe=%0*X acc=%0*X\n", i, k, DATA_WIDTH/4, bandPtr_fix[k] & MASK, DATA_WIDTH/4, table_cos[i][k] & MASK, DATA_WIDTH/4, X_Prime[i] & MASK);
			#endif
		}
	#ifdef DEBUG_SUBSYN
		fprintf(file, "%d: %d (%0*X)\n", i, X_Prime[i], DATA_WIDTH/4, X_Prime[i] & MASK);
	#endif
	}
	
	#ifdef DEBUG_SUBSYN
		fclose(file);
	#endif

#endif

#if NEW_MDCT == 2
	// fast mdct
// 	#define pi 3.141592654
	float pi;
	int N=32;
	int M=2*(int)log2f((float)N);
	fixed_point x[M][N+1];
	float c[M][N+1][2];
	fixed_point a, b;
	int size, iter;
	int PRINT = 0;
	int XPRINT = 0;
	int shift_flag;
	int l;
	
	pi = acos(-1);
	
	#ifdef DEBUG_SUBSYN
	if (ch_count == TARGET_CHANNEL || STEREO == 1) {
		#if DATA_WIDTH == 32
			file = fopen("debug_data/debug_mdct_intermediate_32.txt", OUTPUT_FILE_TYPE);
		#else
			file = fopen("debug_data/debug_mdct_intermediate_16.txt", OUTPUT_FILE_TYPE);
		#endif
		fprintf(file, "// This is frame %d, gr %d, ch %d, SS %d\n", frame_count, gr_count, ch_count, ss);
	}
	#endif
	
	for (i=0; i<N; i++)
		x[0][i]=bandPtr_fix[i];
		
	int mdct_stage = log2f((float)N);
		
	for (i=1; i< mdct_stage+1; i++) 
	{
		size = N/(int)powf(2.0,(float)i);
  	iter = N/size;
		
		for (k=0; k<iter; k++)
			for (j=0; j<size; j++)
				if (k%2)
				{
					c[i-1][size*(k-1)+j][1] = ((1/(2*cos((pi/(4*size))*(2*j+1)))));
					c[i-1][size*(k-1)+2*size-1-j][1] = ((-1/(2*cos((pi/(4*size))*(2*j+1)))));

// 					if (i == 1)	{ c[i-1][size*(k-1)+j][1] /= -8; c[i-1][size*(k-1)+2*size-1-j][1] /= -8;}					
// 					if (i == 2)	{ c[i-1][size*(k-1)+j][1] /= 4; c[i-1][size*(k-1)+2*size-1-j][1] /= 4;}					
// 					if (((i == 3) && ((size*k+j == 31) || (size*k+j == 23) || (size*k+j == 15) || (size*k+j == 7)))) {c[i-1][size*(k-1)+j][1] /= -2;	c[i-1][size*(k-1)+2*size-1-j][1] /= -2;}					
// 					if ((i == 4) && ((size*k+j == 30) || (size*k+j == 22) || (size*k+j == 14) || (size*k+j == 6))) {	c[i-1][size*(k-1)+2*size-1-j][1] *= -2;}
// 					if (i == 5) { c[i-1][size*(k-1)+j][1] *= -2; c[i-1][size*(k-1)+2*size-1-j][1] *= -2;}					

					shift_flag = 0;
					if (c[i-1][size*(k-1)+j][1] > 8.0) {
						c[i-1][size*(k-1)+j][1] = powf(c[i-1][size*(k-1)+j][1], 1.0/4.0);
						c[i-1][size*(k-1)+2*size-1-j][1] = -c[i-1][size*(k-1)+j][1];
						shift_flag = 3;
					} else {
						if (c[i-1][size*(k-1)+j][1] > 4.0) {
							c[i-1][size*(k-1)+j][1] = powf(c[i-1][size*(k-1)+j][1], (1.0/3.0));
							c[i-1][size*(k-1)+2*size-1-j][1] = -c[i-1][size*(k-1)+j][1];
							shift_flag = 2;
						} else {
							if (c[i-1][size*(k-1)+j][1] > 2.0) {
								c[i-1][size*(k-1)+j][1] = powf(c[i-1][size*(k-1)+j][1], 1.0/2.0);
								c[i-1][size*(k-1)+2*size-1-j][1] = -c[i-1][size*(k-1)+j][1];
								shift_flag = 1;
							}
						}
					}

					a = f_adjusted_translate_number(c[i-1][size*(k-1)+j][1]);
          b = f_adjusted_translate_number(c[i-1][size*(k-1)+2*size-1-j][1]);
					x[i][size*k+j] = fix_mul(a, x[i-1][size*(k-1)+j]) + 
									 				fix_mul(b, x[i-1][size*(k-1)+2*size-1-j]);

					for (l = 0; l < shift_flag; l++) {
						x[i][size*k+j] = fix_mul(a, x[i][size*k+j]);
					}
									 													 
					if (PRINT)	{
						printf("a[%d][%d] = (%.2f)*a[%d][%d]+(%.2f)*a[%d][%d]", 
													i, size*k+j, 
													c[i-1][size*(k-1)+j][1], 
													i-1, size*(k-1)+j, 
													c[i-1][size*(k-1)+2*size-1-j][1], 
													i-1, size*(k-1)+2*size-1-j);
						if (shift_flag > 0) printf(" shift_flag=%d\n", shift_flag);
						else printf("\n");
					}

					#ifdef DEBUG_SUBSYN
						fprintf(file, "a[%2d][%2d] (%0*X) = (%0*X) * a[%2d][%2d] (%0*X) + (%0*X) * a[%2d][%2d] (%0*X)", 
													i, size*k+j, 
													DATA_WIDTH/4, x[i][size*k+j] & MASK,
													DATA_WIDTH/4, a & MASK,
													i-1, size*(k-1)+j, 
													DATA_WIDTH/4, x[i-1][size*(k-1)+j] & MASK,
													DATA_WIDTH/4, b & MASK,
													i-1, size*(k-1)+2*size-1-j,
													DATA_WIDTH/4, x[i-1][size*(k-1)+2*size-1-j] & MASK);

						if (shift_flag > 0) fprintf(file, " shift_flag=%d\n", shift_flag);
						else fprintf(file, "\n");
					#endif
					
					if (XPRINT)	printf("x[%d][%d] = (%d), shift_flag=%d\n", 
													i, size*k+j, x[i][size*k+j], shift_flag);													
				}
				else 
				{
					c[i-1][size*(k)+j][0] = 1.0;
					c[i-1][size*(k)+2*size-1-j][0] = 1.0;

// 					if (i == 1) {c[i-1][size*(k)+j][0] /= -8; c[i-1][size*(k)+2*size-1-j][0] /= -8;}					
// 					if (i == 2)	{c[i-1][size*(k)+j][0] /= 4; c[i-1][size*(k)+2*size-1-j][0] /= 4;}					
// 					if ((i == 4) && ((size*k+j == 28) || (size*k+j == 20) || (size*k+j == 12) || (size*k+j == 4))) {c[i-1][size*(k)+2*size-1-j][0] *= -2;}
// 					if (i == 5)	{c[i-1][size*(k)+j][0] *= -2; c[i-1][size*(k)+2*size-1-j][0] *= -2;}					

					a = f_adjusted_translate_number(c[i-1][size*(k)+j][0]);
					b = f_adjusted_translate_number(c[i-1][size*(k)+2*size-1-j][0]);

// 					if (c[i-1][size*(k)+j][0] > 2.0 || c[i-1][size*(k)+j][0] < -2.0) printf("haha: c=%f\n", c[i-1][size*(k)+j][0]);
// 					if (c[i-1][size*(k)+2*size-1-j][0] > 2.0 || c[i-1][size*(k)+2*size-1-j][0] < -2.0) printf("haha: c=%f\n", c[i-1][size*(k)+2*size-1-j][0]);

					x[i][size*k+j] = fix_mul(a, x[i-1][size*(k)+j]) + 
											 		fix_mul(b, x[i-1][size*(k)+2*size-1-j]);
											 		
					if (PRINT) printf("a[%d][%d] = (%.2f)*a[%d][%d]+(%.2f)*a[%d][%d]\n", 
										i, size*k+j, 
										c[i-1][size*(k)+j][0], 
										i-1, size*(k)+j, 
										c[i-1][size*(k)+2*size-1-j][0], 
										i-1, size*(k)+2*size-1-j);

					#ifdef DEBUG_SUBSYN
						fprintf(file, "a[%2d][%2d] (%0*X) = (%0*X) * a[%2d][%2d] (%0*X) + (%0*X) * a[%2d][%2d] (%0*X)", 
													i, size*k+j, 
													DATA_WIDTH/4, x[i][size*k+j] & MASK,
													DATA_WIDTH/4, a & MASK,
													i-1, size*(k)+j, 
													DATA_WIDTH/4, x[i-1][size*(k)+j] & MASK,
													DATA_WIDTH/4, b & MASK,
													i-1, size*(k)+2*size-1-j,
													DATA_WIDTH/4, x[i-1][size*(k)+2*size-1-j] & MASK);
						fprintf(file, "\n");
					#endif

					if (XPRINT)	printf("x[%d][%d] = (%d)\n", 
													i, size*k+j, x[i][size*k+j]);													
				}
		if (PRINT || XPRINT) printf("\n");
		
		#ifdef DEBUG_SUBSYN
			fprintf(file, "\n");
		#endif
	}

	for (i = mdct_stage+1; i < M; i++)  
	{
		size*=2;
		iter/=2;
		for (k=0; k<iter; k++)
			for (j=0; j<size; j++)
				if (k%2)
				{
					if (j != size-1)
					{
// 						c[i-1][k*size+j][1] = -2;
// 						c[i-1][k*size+j+1][1] = -2; 
						c[i-1][k*size+j][1] = 1.0;
						c[i-1][k*size+j+1][1] = 1.0; 
						
// 						x[i][(k-1)*size+2*j+1] = c[i-1][k*size+j][1] * x[i-1][k*size+j] + 
// 												c[i-1][k*size+j+1][1] * x[i-1][k*size+j+1]; 
												
						a = f_adjusted_translate_number(c[i-1][k*size+j][1]);
						b = f_adjusted_translate_number(c[i-1][k*size+j+1][1]);

						x[i][(k-1)*size+2*j+1] = fix_mul(a, x[i-1][k*size+j]) + 
																		fix_mul(b, x[i-1][k*size+j+1]); 

						if (PRINT) printf("a[%d][%d] = (%.2f)*a[%d][%d]+(%.2f)*a[%d][%d]\n", i, (k-1)*size+2*j+1, 
															c[i-1][k*size+j][1], 
															i-1, k*size+j, 
															c[i-1][k*size+j+1][1], 
															i-1, k*size+j+1);

					#ifdef DEBUG_SUBSYN
						fprintf(file, "a[%2d][%2d] (%0*X) = (%0*X) * a[%2d][%2d] (%0*X) + (%0*X) * a[%2d][%2d] (%0*X)", 
													i, (k-1)*size+2*j+1, 
													DATA_WIDTH/4, x[i][(k-1)*size+2*j+1] & MASK,
													DATA_WIDTH/4, a & MASK,
													i-1, k*size+j, 
													DATA_WIDTH/4, x[i-1][k*size+j] & MASK,
													DATA_WIDTH/4, b & MASK,
													i-1, k*size+j+1,
													DATA_WIDTH/4, x[i-1][k*size+j+1] & MASK);
						fprintf(file, "\n");
					#endif

						if (XPRINT)	printf("x[%d][%d] = (%d)\n", 
													i, (k-1)*size+2*j+1, x[i][(k-1)*size+2*j+1]);													
					}
					else
					{
// 						c[i-1][k*size+j][1] = -2;
// 						c[i-1][k*size+j+1][1] = 0;
						c[i-1][k*size+j][1] = 1.0;
						c[i-1][k*size+j+1][1] = 0.0;
// 						x[i][(k-1)*size+2*j+1] = c[i-1][k*size+j][1] * x[i-1][k*size+j] + 
// 												c[i-1][k*size+j+1][1] * x[i-1][k*size+j+1]; 

						a = f_adjusted_translate_number(c[i-1][k*size+j][1]);
						b = f_adjusted_translate_number(c[i-1][k*size+j+1][1]);

						x[i][(k-1)*size+2*j+1] = fix_mul(a, x[i-1][k*size+j]) + 
																		fix_mul(b, x[i-1][k*size+j+1]); 


						if (PRINT) printf("a[%d][%d] = (%.2f)*a[%d][%d]+(%.2f)*a[%d][%d]\n", i, (k-1)*size+2*j+1, 
															c[i-1][k*size+j][1], i-1, k*size+j, 
															c[i-1][k*size+j+1][1], i-1, k*size+j+1);

					#ifdef DEBUG_SUBSYN
						fprintf(file, "a[%2d][%2d] (%0*X) = (%0*X) * a[%2d][%2d] (%0*X) + (%0*X) * a[%2d][%2d] (%0*X)", 
													i, (k-1)*size+2*j+1, 
													DATA_WIDTH/4, x[i][(k-1)*size+2*j+1] & MASK,
													DATA_WIDTH/4, a & MASK,
													i-1, k*size+j, 
													DATA_WIDTH/4, x[i-1][k*size+j] & MASK,
													DATA_WIDTH/4, b & MASK,
													i-1, k*size+j+1,
													DATA_WIDTH/4, x[i-1][k*size+j+1] & MASK);
						fprintf(file, "\n");
					#endif
															
						if (XPRINT)	printf("x[%d][%d] = (%d)\n", 
													i, (k-1)*size+2*j+1, x[i][(k-1)*size+2*j+1]);													
					}
				}
				else
				{
// 					c[i-1][k*size+j][0] = -2;
// 					c[i-1][k*size+j+1][0] = 0;
					c[i-1][k*size+j][0] = 1.0;
					c[i-1][k*size+j+1][0] = 0.0;
// 					x[i][k*size+2*j] = c[i-1][k*size+j][0] * x[i-1][k*size+j] + 
// 									   c[i-1][k*size+j+1][0] * x[i-1][k*size+j+1];
									   
						a = f_adjusted_translate_number(c[i-1][k*size+j][0]);
						b = f_adjusted_translate_number(c[i-1][k*size+j+1][0]);

						x[i][k*size+2*j] = fix_mul(a, x[i-1][k*size+j]) + 
																		fix_mul(b, x[i-1][k*size+j+1]); 
									   
					if (PRINT) printf("a[%d][%d] = (%.2f)*a[%d][%d]+(%.2f)*a[%d][%d]\n", i, k*size+2*j, 
															c[i-1][k*size+j][0], i-1, k*size+j, 
															c[i-1][k*size+j+1][0], i-1, k*size+j+1);
					#ifdef DEBUG_SUBSYN
						fprintf(file, "a[%2d][%2d] (%0*X) = (%0*X) * a[%2d][%2d] (%0*X) + (%0*X) * a[%2d][%2d] (%0*X)", 
													i, k*size+2*j, 
													DATA_WIDTH/4, x[i][k*size+2*j] & MASK,
													DATA_WIDTH/4, a & MASK,
													i-1, k*size+j, 
													DATA_WIDTH/4, x[i-1][k*size+j] & MASK,
													DATA_WIDTH/4, b & MASK,
													i-1, k*size+j+1,
													DATA_WIDTH/4, x[i-1][k*size+j+1] & MASK);
						fprintf(file, "\n");
					#endif
																														
						if (XPRINT)	printf("x[%d][%d] = (%d)\n", 
													i, k*size+2*j, x[i][k*size+2*j]);													
				}
		if (PRINT || XPRINT) printf("\n");
		#ifdef DEBUG_SUBSYN
			fprintf(file, "\n");
		#endif
	}

	for (i=0; i<N; i++) {
		X_Prime[i] = x[M-1][i];
	}
	#ifdef DEBUG_SUBSYN
		fclose(file);
	#endif

if (PRINT || XPRINT) getchar();
#endif

#if NEW_MDCT == 3
	int N=32;
	float pi = acos(-1);
	fixed_point coefficient;
	fixed_point *x_in, *x_out;
	
	
	x_in = bandPtr_fix;
	x_out = X_Prime;

	for (i=0; i<N; i++)
	{
		x_out[i] = 0;
		for (k=0; k<N; k++) {
			coefficient = f_adjusted_translate_number(cos((2*k+1)*i*(pi/(2*N))));
			x_out[i] += fix_mul(coefficient, x_in[k]);
		}
	}			
#endif
