// 
//  MAC_MP3: A Low Energy Implementation of an Audio Decoder
//
//  Copyright (C) 2007 McMaster University
// 
//==============================================================================
// 
// This file is part of MAC_MP3
// 
// MAC_MP3 is distributed in the hope that it will be useful for further research,
// but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. MAC_MP3 is free; you can redistribute it
// and/or modify it provided that proper reference is provided to the authors. See
// the documents included in the "doc" folder for further details.
//
//==============================================================================


#include <iostream>
#include <fstream>
#include <iomanip>
#include <stack>
using namespace std;

void printstack(stack <unsigned int> &s)
{
  unsigned c = 16;
  while (c > s.size())
  {
    cout << "0000";
    c--;
  }
  while (!s.empty())
  {
    cout << hex << std::setfill('0')<< std::setw(4) << s.top();// << endl;
    s.pop();
  }
  cout << endl;
}

int main(int argc, char **argv)
{
  ifstream fp_in;
  fp_in.open(argv[1], ios::in | ios::binary);

  stack <unsigned int> y;
  unsigned int x = 0;
  
  for (int d=0;d<(32*2048);d++)
  {
    x += fp_in.get();
    if (d % 2 == 1)
    {
      y.push(x);
      x = 0;
      if (d % 32 == 31)
        printstack(y);
    }
    else
      x <<= 8;
  }
  
  fp_in.close();
  return 0;
}
