#include <math.h>
#include <stdarg.h>

#include "custom.h"

fixed_point f_adjusted_translate_float(float input) {
	fixed_point output;
	int temp1, temp2;

	temp1 = input * pow(2, 30);
	temp2 = 0;
	
	#if DATA_WIDTH == 16
		output = (temp1 & 0xFFFF0000) >> 16;
		temp2 = temp1 & 0x0000FF00;
	
		if (temp2) {
			if (output >= 0) output += 1;
			else output -= 1;
		}
	#else
		output = temp1;
	#endif

//	printf("haha: %.10f, %d, %08X, %d, %08X, %d, %0*X\n", input, temp1, temp1, temp2, temp2, output, BITWIDTH/4, output & MASK);
//	getchar();

	return output;	
}

fixed_point f_adjusted_translate_double(double input) {
	fixed_point output;
	int temp1, temp2;
	float temp3;
	
	temp3 = (float)input;

	temp1 = temp3 * pow(2, 30);
	temp2 = 0;
	
	#if DATA_WIDTH == 16
		output = (temp1 & 0xFFFF0000) >> 16;
		temp2 = temp1 & 0x0000FF00;
	
		if (temp2) {
			if (output >= 0) output += 1;
			else output -= 1;
		}
	#else
		output = temp1;
	#endif

//	printf("haha: %.10f, %d, %08X, %d, %08X, %d, %0*X\n", input, temp1, temp1, temp2, temp2, output, BITWIDTH/4, output & MASK);
//	getchar();

	return output;	
}

void f_temp_print(const char *fmt, ...) {
	va_list ap;

	va_start(ap, fmt);
	
	vfprintf(temp_fp, fmt, ap);
	fflush(temp_fp);

	va_end(ap);
}
